
/************************** Error Code ************************************************************/
#define HC_OK					0		//操作成功 
#define HC_ERROR_INIT				-0x0001		//初始化通信端口失败
#define HC_ERROR_CLOSE				-0x0002		//关闭通信端口失败
#define HC_ERROR_COM_BUSY			-0x0003		//串口被占用
#define HC_ERROR_PARAM_BAUD			-0x0004		//不支持的串口波特率
#define HC_ERROR_NODEVICE			-0x0005		//未扫描到设备
#define HC_ERROR_NOTEXIST			-0x0006		//设备未连接
#define HC_ERROR_HANDLE				-0x0007		//无效的句柄
#define HC_ERROR_COMMUNICATE			-0x0008		//通讯发生错误
#define HC_ERROR_DATAFORMAT			-0x0009		//通讯数据格式错误
#define HC_ERROR_PARAM				-0x000A		//参数错误
#define HC_ERROR_PARAM_LENGTH			-0x000B		//数据长度错误
#define HC_ERROR_ADDRESS_OVERFLOW		-0x000C		//地址越界      
#define HC_ERROR_PARAM_OVERFLOW			-0x000D		//缓冲区溢出
#define HC_ERROR_TIMEOUT			-0x000E		//操作超时
#define HC_ERROR_CARD_WRITE			-0x000F		//写(卡片)错误
#define HC_ERROR_CARD_READ			-0x0010		//读(卡片)错误
#define HC_ERROR_BCC				-0x0011		//BCC校验和错误
#define HC_ERROR_PARAM_SLOT			-0x0012		//不支持的卡座编号
#define HC_ERROR_CARDTYPE			-0x0013		//卡片类型错误
#define HC_ERROR_NOPOWER			-0x0014		//卡座有卡未上电
#define HC_ERROR_NOCARD				-0x0015		//未检测到卡片
#define HC_ERROR_NOT_VALID_CARD			-0x0016		//无效卡

#define HC_ERROR_LOADKEY			-0x0017		//装载密码出错
#define HC_ERROR_GETREADERKEY			-0x0018		//获取读卡器密码错误
#define HC_ERROR_UNKNOWN			-0x0019		//读卡器未知错误

#define HC_ERROR_REQUEST			-0x001A		//请求失败
#define HC_ERROR_ANTICOLL			-0x001B		//防冲突失败
#define HC_ERROR_SELECT				-0x001C		//选卡失败
#define HC_ERROR_AUTHAENTICATION		-0x001D		//认证错误
#define HC_ERROR_VALUE_FORMAT			-0x001E		//非值存储区域
#define HC_ERROR_VALUE_OVERFLOW			-0x001F		//值溢出错误
#define HC_ERROR_RESTORE			-0x0020		//restore出错
#define HC_ERROR_TRANSFER			-0x0021		//transfer出错
#define HC_ERROR_INCREMENT			-0x0022		//增值错误
#define HC_ERROR_DECREMENT			-0x0023		//减值错误 
#define HC_ERROR_MIFARE_VALUE			-0x0024		//Mifare值操作失败
#define HC_ERROR_MAGCARD_DATA			-0x0025		//磁条卡数据错误

#define HC_ERROR_SC_RESET			-0x0026		//CPU卡复位出错
#define HC_ERROR_SC_APDU			-0x0027		//CPU卡APDU失败
#define HC_ERROR_NOTSUPPORT			-0x0028		//命令不支持
#define HC_ERROR_SYSTEM				-0x0029		//系统操作出错
#define HC_ERROR_PASSWORD			-0x002A		//密码错误
#define HC_ERROR_LOADLIBRARY			-0x002B		//加载动态库失败
#define HC_ERROR_GETIMAGE				-0x002C      //获取身份证图片失败

#define HC_ERROR_READER_TIMEOUT					-0x0040		//未收到卡片回复
#define HC_ERROR_UNFULFILLED					-0x0041	    //未实现的操作

/****** 超高频错误代码 ***********************************************************************************/
#define HC_ERROR_UHF_COMMAND					-0x0050		//命令帧中指令代码错误
#define HC_ERROR_UHF_FHSS						-0x0051		//跳频搜索信道超时。所有信道在这段时间内都被占用
#define HC_ERROR_UHF_INVENTORY					-0x0052		//轮询操作失败。没有标签返回或者返回数据 CRC 校验错误
#define HC_ERROR_UHF_ACCESS						-0x0053		//访问标签失败，有可能是访问密码 password 不对
#define HC_ERROR_UHF_READ						-0x0054		//读标签数据存数区失败。标签没有返回或者返回数据 CRC 校验错误
#define HC_ERROR_UHF_WRITE						-0x0055		//写标签数据存数区失败。标签没有返回或者返回数据 CRC 校验错误
#define HC_ERROR_UHF_LOCK						-0x0056		//锁定标签数据存数区失败。标签没有返回或者返回数据 CRC 校验错误
#define HC_ERROR_UHF_KILL						-0x0057		//灭活标签失败。标签没有返回或者返回数据 CRC 校验错误 
#define HC_ERROR_UHF_READPROTECT				-0x0058		//ReadProtect 指令失败，标签没有返回数据或者返回数据 CRC 校验错误
#define HC_ERROR_UHF_RESET_READPROECT			-0x0059		//Reset ReadProtect 指令失败，标签没有返回数据或者返回数据 CRC 校验错误
#define	HC_ERROR_UHF_CHANGE_EAS					-0x005A		//Change EAS 指令失败，标签没有返回数据或者返回数据 CRC 校验错误
#define HC_ERROR_UHF_MEMORY_OVERRUN				-0x005B		//指定的标签数据区不存在或标签不支持指定长度的EPC
#define HC_ERROR_UHF_MEMORY_LOCKED				-0x005C		//指定的标签数据区被锁定并且/或者是永久锁定,而且锁定状态为不可写或不可读
#define HC_ERROR_UHF_INSUFFICIENT_POWER			-0x005D		//标签没有收到足够的能量来读写操作
#define HC_ERROR_UHF_OTHER						-0x005E		//标签返回的其它未知错误。

//**********************    commual subroutine    ***********************
short hc_init(char* spName, unsigned long baud);
short hc_init_usb();
short hc_exit();
short set_baud(unsigned long baud);

short srd_ver(unsigned char *data_buffer);

short turn_on();
short turn_off();
short get_status(short *state);
short dv_beep(short time);

short swr_eeprom(short offset, short len, unsigned char *data_buffer);
short srd_eeprom(short offset, short len, unsigned char *data_buffer);
short srd_snr(unsigned char *data_buffer);
short swr_snr(unsigned char *data_buffer);

short swr_reader_info(char* info);
short srd_reader_info(char* info);

short chk_card();

/**
* Function: rf_select_protocol
*
* Description: 选择协议, 对于多协议读写器, 操作卡片前需要选择卡片相应的协议才可操作卡片.
*
* Input:
*		protype: 协议类型. 0 -- ISO14443 TypeA; 1 -- ISO14443 TypeB; 2 -- ISO15693
*
* Return: 等于0成功, 小于0表示失败.
*/
short rf_select_protocol(unsigned char protype);

//***********************    operate tools    *************************
short ic_encrypt(char *key, char *ptrSource, unsigned short msgLen, char *ptrDest);
short ic_decrypt(char *key, char *ptrSource, unsigned short msgLen, char *ptrDest);
unsigned long DES_Encrypt(unsigned char *Key, short KeyLen,
	unsigned char *Source, unsigned long SrcLen, unsigned char *result);
unsigned long DES_Decrypt(unsigned char *Key, short KeyLen,
	unsigned char *Source, unsigned long SrcLen, unsigned char *result);
short asc_hex(char *asc, unsigned char *hex, int pair_len);
short hex_asc(unsigned char *hex,  char *asc, int length);

//**********************    operate sle 4404    **************************
short srd_4404(short offset, short len, unsigned char *data_buffer);
short swr_4404(short offset, short len, unsigned char *data_buffer);
short csc_4404(short len, unsigned char *data_buffer);
short wsc_4404(short len, unsigned char *data_buffer);
short rsc_4404(short len, unsigned char *data_buffer);
short rsct_4404(short *counter);
short cesc_4404(short len, unsigned char *data_buffer);
short wesc_4404(short len, unsigned char *data_buffer);
short resc_4404(short len, unsigned char *data_buffer);
short resct_4404(short *counter);
short ser_4404(short offset, short len);
short fakefus_4404(short mode);
short clrpr_4404();
short clrrd_4404();
short psnl_4404();
short chk_4404();
//***********************    operate sle 4406    *************************
short srd_4406(short offset, short len, unsigned char *data_buffer);
short swr_4406(short offset, short len, unsigned char *data_buffer);
short csc_4406(short len, unsigned char *data_buffer);
short wsc_4406(short len, unsigned char *data_buffer);
short rsc_4406(short len, unsigned char *data_buffer);
short rsct_4406(short *Counter);
short eswc_4406(short offset);
short psnl_4406();
short chk_4406();

//***********************    operate at88sc102    ************************
short srd_102(short zone, short offset, short len, unsigned char *data_buffer);
short swr_102(short zone, short offset, short len, unsigned char *data_buffer);
short ser_102(short zone, short offset, short len);

short csc_102(short len, unsigned char *data_buffer);
short rsc_102(short len, unsigned char *data_buffer);
short wsc_102(short len, unsigned char *data_buffer);
short rsct_102(short *counter);

short cesc_102(short zone, short len, unsigned char *data_buffer);
short resc_102(short zone, short len, unsigned char *data_buffer);
short wesc_102(short zone, short len, unsigned char *data_buffer);
short resct_102(short zone, short *counter);

short clrpr_102(short zone);
short clrrd_102(short zone);

short fakefus_102(short mode);
short psnl_102();
short chk_102();
//*********************    operate at88sc1604    **************************
short srd_1604(short zone, short offset, short len, unsigned char *data_buffer);
short swr_1604(short zone, short offset, short len, unsigned char *data_buffer);
short ser_1604(short zone, short offset, short len);

short csc_1604(short zone, short len, unsigned char *data_buffer);
short rsc_1604(short zone, short len, unsigned char *data_buffer);
short wsc_1604(short zone, short len, unsigned char *data_buffer);
short rsct_1604(short zone, short *counter);

short cesc_1604(short zone, short len, unsigned char *data_buffer);
short resc_1604(short zone, short len, unsigned char *data_buffer);
short wesc_1604(short zone, short len, unsigned char *data_buffer);
short resct_1604(short zone, short *counter);

short clrpr_1604(short zone);
short clrrd_1604(short zone);

short fakefus_1604(short mode);
short psnl_1604();
short chk_1604();
//*********************    operate at88sc1604b    **************************
short srd_1604b(short zone, short offset, short len, unsigned char *data_buffer);
short swr_1604b(short zone, short offset, short len, unsigned char *data_buffer);
short ser_1604b(short zone, short offset, short len);

short csc_1604b(short zone, short len, unsigned char *data_buffer);
short rsc_1604b(short zone, short len, unsigned char *data_buffer);
short wsc_1604b(short zone, short len, unsigned char *data_buffer);
short rsct_1604b(short zone, short *counter);

short cesc_1604b(short zone, short len, unsigned char *data_buffer);
short resc_1604b(short zone, short len, unsigned char *data_buffer);
short wesc_1604b(short zone, short len, unsigned char *data_buffer);
short resct_1604b(short zone, short *counter);

short clrpr_1604b(short zone);
short clrrd_1604b(short zone);

short fakefus_1604b(short mode);
short psnl_1604b();
short chk_1604b();

//************************    operate at24c01A    ***************************
short swr_24c01a(short offset, short len,
	unsigned char *data_buffer);
short srd_24c01a(short offset, short len,
	unsigned char *data_buffer);
short chk_24c01a();
//************************    operate at24c02    ***************************
short swr_24c02(short offset, short len,
	unsigned char *data_buffer);
short srd_24c02(short offset, short len,
	unsigned char *data_buffer);
short chk_24c02();
//************************    operate at24c04    ***************************
short swr_24c04(short offset, short len,
	unsigned char *data_buffer);
short srd_24c04(short offset, short len,
	unsigned char *data_buffer);
short chk_24c04();
//************************    operate at24c08    ***************************
short swr_24c08(short offset, short len,
	unsigned char *data_buffer);
short srd_24c08(short offset, short len,
	unsigned char *data_buffer);
short chk_24c08();
//************************    operate at24c16    ***************************
short swr_24c16(short offset, short len,
	unsigned char *data_buffer);
short srd_24c16(short offset, short len,
	unsigned char *data_buffer);
short chk_24c16();
//************************    operate at24c32    ***************************
short swr_24c32(short offset, short len,
	unsigned char *data_buffer);
short srd_24c32(short offset, short len,
	unsigned char *data_buffer);
short chk_24c32();
//************************    operate at24c64    ***************************
short swr_24c64(short offset, short len,
	unsigned char *data_buffer);
short srd_24c64(short offset, short len,
	unsigned char *data_buffer);
short chk_24c64();
//************************    operate at24c128    ***************************
short swr_24c128(short offset, short len,
	unsigned char *data_buffer);
short srd_24c128(short offset, short len,
	unsigned char *data_buffer);
short chk_24c128();
//************************    operate at24c256    ***************************
short swr_24c256(short offset, short len,
	unsigned char *data_buffer);
short srd_24c256(short offset, short len,
	unsigned char *data_buffer);
short chk_24c256();
//************************    operate at24c512    ***************************
short swr_24c512(short offset, short len,
	unsigned char *data_buffer);
short srd_24c512(short offset, short len,
	unsigned char *data_buffer);
short chk_24c512();
//************************    operate at24c1024    ***************************
short swr_24c1024(int offset, short len,
	unsigned char *data_buffer);
short srd_24c1024(int offset, short len,
	unsigned char *data_buffer);
short chk_24c1024();
//***********************    operate sle 4418    *************************
short srd_4418(short offset, short len, unsigned char *data_buffer);
short swr_4418(short offset, short len, unsigned char *data_buffer);
short rdwpb_4418(short offset, short len, unsigned char *data_buffer);
short wrwpb_4418(short offset, short len, unsigned char *data_buffer);
short pwr_4418(short offset, short len, unsigned char *data_buffer);
short chk_4418();
//***********************    operate sle 4428    *************************
short srd_4428(short offset, short len, unsigned char *data_buffer);
short swr_4428(short offset, short len, unsigned char *data_buffer);
short rdwpb_4428(short offset, short len, unsigned char *data_buffer);
short wrwpb_4428(short offset, short len, unsigned char *data_buffer);
short pwr_4428(short offset, short len, unsigned char *data_buffer);
short csc_4428(unsigned char *data_buffer);
short wsc_4428(unsigned char *data_buffer);
short rsc_4428(unsigned char *data_buffer);
short rsct_4428(short *counter);
short chk_4428();
//***********************    operate sle 4442    **************************
short srd_4442(short offset, short len, unsigned char *data_buffer);
short swr_4442(short offset, short len, unsigned char *data_buffer);
short prd_4442(short len, unsigned char *data_buffer);
short pwr_4442(short offset, short len, unsigned char *data_buffer);
short csc_4442(unsigned char *data_buffer);
short wsc_4442(unsigned char *data_buffer);
short rsc_4442(unsigned char *data_buffer);
short rsct_4442(short *counter);
short chk_4442();

//***********************    operate sle 4432    **************************
short srd_4432(short offset, short len,
	unsigned char *data_buffer);
short swr_4432(short offset, short len,
	unsigned char *data_buffer);
short prd_4432(short len,
	unsigned char *data_buffer);
short pwr_4432(short offset, short len,
	unsigned char *data_buffer);
short chk_4432();

//***********************    operate at45d041    *************************
short srd_45d041(short page, short offset, unsigned long len,
	unsigned char *data_buffer);
short swr_45d041(short page, short offset, unsigned long len,
	unsigned char *data_buffer);
short rdstrg_45d041(unsigned char *ch);
short chk_45d041();
//************************    operate at93c46a    ***************************
short swr_93c46a(short offset, short len,
	unsigned char *data_buffer);
short srd_93c46a(short offset, short len,
	unsigned char *data_buffer);
short eral_93c46a();
short chk_93c46a();
//************************    operate at93c46    ***************************
short swr_93c46(short offset, short len, unsigned char *data_buffer);
short srd_93c46(short offset, short len, unsigned char *data_buffer);
short eral_93c46();
short chk_93c46();
short exp_dis(char *filename, short *no);
short get_status0(short *state);
short set_code(short CardType, short num, short len, unsigned char *code);
short swr_snr(unsigned char *data_buffer);
//*********************    operate at88sc1608    **************************
short reset_1608(short len, unsigned char *data_buffer);
short init_auth_1608(short len, unsigned char *data_buffer);
//short vrf_1608(short len, unsigned char *data_buffer);
short callsrd_1608(short zone, short offset, short len, unsigned char *data_buffer);
short srd_1608(short zone, short offset, short len, unsigned char *data_buffer);
short srfus_1608(short len, unsigned char *data_buffer);
short callswr_1608(short zone, short offset, short len, unsigned char *data_buffer);
short swr_1608(short zone, short offset, short len, unsigned char *data_buffer);
short csc_1608(short zone, short len, short rw, unsigned char *data_buffer);
short psnl_1608();
short wsc_1608(short zone, short len, short rw, unsigned char *data_buffer);
short rsc_1608(short zone, short len, short rw, unsigned char *data_buffer);
short rsct_1608(short zone, short len, short rw, unsigned char *data_buffer);
short rac_1608(short zone, short len, unsigned char *data_buffer);
short wac_1608(short zone, short len, unsigned char *data_buffer);
short chk_1608();
short srdconfig_1608(short offset, short len, unsigned char *data_buffer);
short swrconfig_1608(short offset, short len, unsigned char *data_buffer);
void   Authenticate(unsigned char *q1, unsigned char *q2);
void   SetInit(unsigned char *crypto, unsigned char *graine, unsigned char *host);

//*********************    operate at88sc153    **************************
short reset_153(short len, unsigned char *data_buffer);

short init_auth_153(short len, unsigned char *data_buffer);

short chk_153();

short srd_153(short zone, short offset, short len, unsigned char *data_buffer);

short swr_153(short zone, short offset, short len, unsigned char *data_buffer);

short srdconfig_153(short offset, short len, unsigned char *data_buffer);

short swrconfig_153(short offset, short len, unsigned char *data_buffer);

short rac_153(short zone, short len, unsigned char *data_buffer);

short wac_153(short zone, short len, unsigned char *data_buffer);

short rautht_153(short len, unsigned char *data_buffer);

short rdcr_153(short len, unsigned char *data_buffer);

short wdcr_153(short len, unsigned char *data_buffer);

short csc_153(short psw_set, short rw, short len, unsigned char *data_buffer);

short rsc_153(short psw_set, short rw, short len, unsigned char *data_buffer);

short wsc_153(short psw_set, short rw, short len, unsigned char *data_buffer);

short rsct_153(short psw_set, short rw, short len, unsigned char *data_buffer);

short srfus_153(short len, unsigned char *data_buffer);

short swfus_153(unsigned char data_fus);

short psnl_153();

//*************************    operate cpu card    ************************
short cpu_reset(unsigned int *rlen, unsigned char *rbuffer);

short cpu_protocol(unsigned int slen, unsigned char *sbuffer,
	unsigned int *rlen, unsigned char *rbuffer);

//************************* sam card ****************************************
short sam_slt_power_on(unsigned char CardType);
short sam_slt_power_down(unsigned char CardType);

short sam_slt_reset(unsigned char CardType, unsigned char *rbuffer);

short sam_slt_protocol(unsigned char CardType, unsigned int slen, unsigned char *sbuffer, unsigned char *rbuffer);

short set_card_baud(unsigned char CardType, unsigned char BaudCode);
/*
CardType=0,		Cpu
CardType=1,		SAM1
CardType=2,		SAM2
CardType=3,		SAM3
CardType=4,		SAM4
CardType=5,		SAM5


BaudCode=1,		9600
BaudCode=2,		19200
BaudCode=3,		38400*/

short sam_slt_protocol_2(unsigned char CardType, unsigned int slen, unsigned char *sbuffer,
	unsigned int *rlen, unsigned char *rbuffer);

//************************* SSF1101************************************
short srd_ssf1101(short page, short offset, long len,
	unsigned char *data_buffer);
short swr_ssf1101(short page, short offset, long len,
	unsigned char *data_buffer);
short chk_ssf1101();

short eral_ssf1101();


/////////////////////////RF ////////////////////////////////////////////////////////////////////////////////////////
short rf_reset(unsigned short _Msec);
short rf_select_protocal(unsigned char protype);
short rf_get_status();
///////////////////////////  M1   //////////////////////////////////////////////////////////////////////////////////
short rf_request(unsigned char _Mode, unsigned short *TagType);
short rf_request_std(unsigned char _Mode, unsigned short *TagType);
short rf_anticoll(unsigned char *_Snr);
short rf_anticoll2(unsigned char *_Snr);

short rf_select(unsigned char* _Snr, unsigned char *_Size);
short rf_select2(unsigned char* _Snr, unsigned char *_Size);

short rf_card(unsigned char _Mode, unsigned char *_Snr);
short rf_card_7uid(unsigned char _Mode, unsigned char *_Snr);

short rf_halt();
short rf_authentication(unsigned char _Mode, unsigned char _SecNr);
short rf_authentication_2(unsigned char _Mode, unsigned char KeyNr, unsigned char Adr);
short rf_authentication_key(unsigned char _Mode, unsigned char _BlockNr, unsigned char *_Key);
short rf_read(unsigned char _Adr, unsigned char *_Data);
short rf_write(unsigned char _Adr, unsigned char *_Data);
short rf_load_key(unsigned char _Mode, unsigned char _SecNr, unsigned char *_NKey);
short rf_increment(unsigned char _Adr, unsigned int _Value);
short rf_decrement(unsigned char _Adr, unsigned int _Value);
short rf_restore(unsigned char _Adr);
short rf_transfer(unsigned char _Adr);
short rf_decrement_transfer(unsigned char _Adr, unsigned long _Value);
short rf_initval(unsigned char _Adr, unsigned int _Value);
short rf_readval(unsigned char _Adr, unsigned int *_Value);
short rf_changeb3(unsigned char _SecNr, unsigned char *_KeyA, unsigned char _B0, unsigned char _B1, unsigned char _B2, unsigned char _B3, unsigned char _Bk, unsigned char *_KeyB);
////////////////////////   UID card  //////////////////////////////////////////////////////////////////////////////////
short rf_write_block0(unsigned char _Adr, unsigned char *_Data);
////////////////////////   PRO cpu   //////////////////////////////////////////////////////////////////////////////////
short rf_pro_reset(unsigned char *rbuff);
short rf_pro_trn(unsigned int slen, unsigned char *sbuff, unsigned char *rbuff);
short rf_pro_halt();
////////////////////////  TypeB    /////////////////////////////////////////////////////////////////////////////////////
short rf_request_b(unsigned char _Afi, unsigned char _Param, unsigned char *ATQB);
short rf_slotmarker(unsigned char _N, unsigned char *ATQB);
short rf_attrib(unsigned char *PUPI, unsigned char CID, unsigned char _BrTx, unsigned char _BrRx);
short rf_haltb(unsigned char *PUPI);

short read_magnetic_card(
	unsigned char timeout,
	unsigned char *track1_len,
	unsigned char *track1_data,
	unsigned char *track2_len,
	unsigned char *track2_data,
	unsigned char *track3_len,
	unsigned char *track3_data);
short hcReadBankCardNo(char* bankNo);

////////////////////////   Ultralight_C card  //////////////////////////////////////////////////////////////////////////////////
short rf_authentication_ulc_key(unsigned char *_Key);
short rf_changekey_ulc(unsigned char *_Key);

/////////////////// ISO15693(ICode2) ///////////////////////////////////////

/*
* Function: rfICode_SetConfigMode
*
* Description: 设置数据交换模式.
*
* Input:
*       cardtype: 被操作的卡类型: 0 -- ICODE1; 1 -- ICODE2
*       _Mode: 数据交换模式: 0 -- 标准模式, 波特率为 26.5 kbit/s; 1 -- 快模式, 波特率为 53 kbit/s
*
* Return: 等于0成功,其它错误, 请查看错误代码表
*/
short rfICode_SetConfigMode(unsigned char cardtype, unsigned char _Mode);

/*
* Function: rfICode_Inventory
*
* Description: ICode2卡执行防冲突操作，返回卡的 DSFID 和 UID，
*			   对卡片操作之前需要先执行此函数.
*
* Input:
*       afi_flag: 在ISO15693 Inventory过程中是否匹配AFI值。0：否 ；1：是
*       afi: AFI值
*       slot_Flag: ISO15693 Inventory 通道类型.  0 -- 16 通道, 可以操作天线范围内的多张卡; 1 -- 1通道, 只能操作一张卡
* Output:
*		card_info: 应答数据，格式为byte数组.卡的回答信息, 包括 DSFID 和 UID. card_info[0]: 卡信息的长度 card_info[1]: 卡 1 的 DSFID card_info[2]~card_info[9]: 卡 1 的 UID
*		…
*		card_info[(n-1)*9+1]: 卡 n 的 DSFID (n = len / 9) card_info[(n-1)*9+2]~card_info[(n-1)*9+9]: 卡 n 的 UID
*
* Return: 等于0成功,其它错误, 请查看错误代码表
*/
short rfICode_Inventory(unsigned char afi_flag, unsigned char afi, unsigned char slot_Flag, unsigned char *card_info);

/*
* Function: rfICode_SelectUid
*
* Description: 设置卡为选择状态.
*
* Input:
*       uid: 要设置为 Select 状态的卡片UID
*
* Return: 等于0成功,其它错误, 请查看错误代码表
*/
short rfICode_SelectUid(unsigned char *uid);

/*
* Function: rfICode_ResetToReady
*
* Description: 使卡进入 Ready 状态
*
* Input:
*       Select_Flag:  0 -- 根据 Address_flag 的设置选择卡来执行该命令。 1 -- 只有选择状态下的卡能执行该命令
*       Address_Flag:  0 -- 请求不是地址模式，UID 无效，任何卡都执行; 1 -- 请求是地址模式，UID 有较，只有 UID 匹配的卡才 执行该命令。
*       uid: 要设置为 Ready 状态的卡片UID
*
* Return: 等于0成功,其它错误, 请查看错误代码表
*
* Others: 如果 Select_Flag 被设为 1, 则 Address_Flag 应该设为 0 ，并且 UID 无效
*/
short rfICode_ResetToReady(unsigned char Select_Flag, unsigned char Address_Flag, unsigned char *uid);

/*
* Function: rfICode_StayToQuiet
*
* Description: 使卡进入 Quiet 状态,卡片进入 Quiet 状态后不会响应任何命令, 如果要操作卡片必须拿开重新放置在读卡设备上
*
* Input:
*       uid: 要设置为 Quiet 状态的卡片UID
*
* Return: 等于0成功,其它错误, 请查看错误代码表
*/
short rfICode_StayToQuiet(unsigned char *uid);

/*
* Function: rfICode_GetSystemInformation
* Description: 获取系统信息
* Input:
*		Select_Flag:  0 -- 根据 Address_flag 的设置选择卡来执行该命令。 1 -- 只有选择状态下的卡能执行该命令
*       Address_Flag:  0 -- 请求不是地址模式，UID 无效，任何卡都执行; 1 -- 请求是地址模式，UID 有较，只有 UID 匹配的卡才 执行该命令。
*       uid: 要读取数据的卡片UID
* Output:
*		sysinfo: 返回的系统信息
*		sysinfo[0]: 信息长度
*		sysinfo[1]: 信息标记. bit0为DSFID,此位为0时不支持DSFID,为1时支持DSFID; bit1为AFI,此位为0时不支持AFI,为1时支持AFI;
*					 bit2为VICC存储容量信息, 为1时支持, 为0时不支持; bit4为IC reference,为0时有关IC参考信息不支持，相应参数无效,为1时支持,相应参数为效
*		sysinfo[2] ~ sysinfo[9]:  卡的 UID
*		sysinfo[10] ~ sysinfo[len]: 根据信息标记的有关信息代码的标记情况，存放 DSFID、AFI 和其它信息
*
* Return: 等于0成功,其它错误, 请查看错误代码表
*
* Others: 如果 Select_Flag 被设为 1, 则 Address_Flag 应该是 0 并且卡的 UID 无效
*		  如果起始块号和要读取的块数之和大于用户块总数，则能读取的块数据要少于 被请求的块数，也就是说，最后返回的块是最高可用的用户数据块
*/
short rfICode_GetSystemInformation(unsigned char Select_Flag, unsigned char Address_Flag, unsigned char *uid, unsigned char *sysinfo);

/*
* Function: rfICode_ReadMultipleBlocks
*
* Description: 读取多个块信息
*
* Input:
*		Select_Flag:  0 -- 根据 Address_flag 的设置选择卡来执行该命令。 1 -- 只有选择状态下的卡能执行该命令
*       Address_Flag:  0 -- 请求不是地址模式，UID 无效，任何卡都执行; 1 -- 请求是地址模式，UID 有较，只有 UID 匹配的卡才 执行该命令。
*		Option_Flag:  0 -- 卡不返回块的安全状态;  1 -- 返回块的安全状态.
*       uid: 要读取数据的卡片UID
*		startblock: 起始块号，0 ~ 27
*		blocknum: 读取的块数
* Output:
*		_Data: 返回的数据
*		_Data[0]:返回数据的长度
*		如果 Option_Flag = 1 那么 _Data[1]: 块1的安全状态 _Data[2]~_Data[5]:块 1 的内容 … _Data[(n-1)*5+1]: 块 n 的安全状态 ( n = len / 5) _Data[(n-1)*5+2]~_Data[(n-1)*5+5]: 块 n 的内容
*		如果 Option_Flag = 0 那么 _Data[1] ~ _Data[4]: 块 1 的内容 … _Data[(n-1)*4+1]~_Data[(n-1)*4+4]: 块 n 的内容
*
* Return: 等于0成功,其它错误, 请查看错误代码表
*
* Others: 如果 Select_Flag 被设为 1, 则 Address_Flag 应该是 0 并且卡的 UID 无效
*		  如果起始块号和要读取的块数之和大于用户块总数，则能读取的块数据要少于 被请求的块数，也就是说，最后返回的块是最高可用的用户数据块
*/
short rfICode_ReadMultipleBlocks(unsigned char Select_Flag, unsigned char Address_Flag,
	unsigned char Option_Flag, unsigned char *uid, unsigned char startblock, unsigned char blocknum, unsigned char *_Data);

/*
* Function: rfICode_WriteMultipleBlocks
*
* Description: 向多个块写数据.如果在天线范围内有多张, 并且 Select_Flag 和 Address_Flag 都设为0, 则所有处于 ready 都可以写入. 在要写的块中，如果有一块或多块被锁定，则只在第一块锁定的块号前能写入数据，并且返回错误信息。
*
* Input:
*		Select_Flag:  0 -- 根据 Address_flag 的设置选择卡来执行该命令。 1 -- 只有选择状态下的卡能执行该命令
*       Address_Flag:  0 -- 请求不是地址模式，UID 无效，任何卡都执行; 1 -- 请求是地址模式，UID 有较，只有 UID 匹配的卡才 执行该命令。
*       uid: 要写入数据的卡片UID
*		startblock: 起始块号，0 ~ 27
*		blocknum: 写入的块数
*		_Data: 要写入的数据.
*
* Return:	    等于0成功,其它错误, 请查看错误代码表
*
* Others:		如果 Select_Flag 被设为 1, 则 Address_Flag 应该是 0 并且卡的 UID 无效
*/
short rfICode_WriteMultipleBlocks(unsigned char Select_Flag, unsigned char Address_Flag,
	unsigned char *uid, unsigned char startblock, unsigned char blocknum, unsigned char *_Data);

/*
* Function: rfICode_LockBlock
*
* Description: 永久地锁定块
*
* Input:
*		Select_Flag:  0 -- 根据 Address_flag 的设置选择卡来执行该命令。 1 -- 只有选择状态下的卡能执行该命令
*       Address_Flag:  0 -- 请求不是地址模式，UID 无效，任何卡都执行; 1 -- 请求是地址模式，UID 有较，只有 UID 匹配的卡才 执行该命令。
*       uid: 要锁块的卡片UID
*		block: 要锁定的块号，0 ~ 27
*
* Return: 等于0成功,其它错误, 请查看错误代码表
*
* Others: 如果 Select_Flag 被设为 1, 则 Address_Flag 应该是 0 并且卡的 UID 无效
*/
short rfICode_LockBlock(unsigned char Select_Flag, unsigned char Address_Flag,
	unsigned char *uid, unsigned char block);

/*
* Function: rfICode_WriteAFI
*
* Description: 写AFI
*
* Input:
*		Select_Flag:  0 -- 根据 Address_flag 的设置选择卡来执行该命令。 1 -- 只有选择状态下的卡能执行该命令
*       Address_Flag:  0 -- 请求不是地址模式，UID 无效，任何卡都执行; 1 -- 请求是地址模式，UID 有较，只有 UID 匹配的卡才 执行该命令。
*       uid: 卡片UID
*		afi: 要写入的AFI的值
*
* Return: 等于0成功,其它错误, 请查看错误代码表
*
* Others: 如果 Select_Flag 被设为 1, 则 Address_Flag 应该是 0 并且卡的 UID 无效
*/
short rfICode_WriteAFI(unsigned char Select_Flag, unsigned char Address_Flag,
	unsigned char *uid, unsigned char afi);

/*
* Function: rfICode_WriteDSFID
*
* Description: 写DSFID
*
* Input:
*		Select_Flag:  0 -- 根据 Address_flag 的设置选择卡来执行该命令。 1 -- 只有选择状态下的卡能执行该命令
*       Address_Flag:  0 -- 请求不是地址模式，UID 无效，任何卡都执行; 1 -- 请求是地址模式，UID 有较，只有 UID 匹配的卡才 执行该命令。
*       uid: 卡片UID
*		afi: 要写入的DSFID的值
*
* Return: 等于0成功,其它错误, 请查看错误代码表
*
* Others: 如果 Select_Flag 被设为 1, 则 Address_Flag 应该是 0 并且卡的 UID 无效
*/
short rfICode_WriteDSFID(unsigned char Select_Flag, unsigned char Address_Flag,
	unsigned char *uid, unsigned char dsfid);

/*
* Function: rfICode_LockDSFID
*
* Description: 锁定DSFID
*
* Input:
*		Select_Flag:  0 -- 根据 Address_flag 的设置选择卡来执行该命令。 1 -- 只有选择状态下的卡能执行该命令
*       Address_Flag:  0 -- 请求不是地址模式，UID 无效，任何卡都执行; 1 -- 请求是地址模式，UID 有较，只有 UID 匹配的卡才 执行该命令。
*       uid: 卡片UID
*
* Return: 等于0成功,其它错误, 请查看错误代码表
*
* Others: 如果 Select_Flag 被设为 1, 则 Address_Flag 应该是 0 并且卡的 UID 无效
*/
short rfICode_LockDSFID(unsigned char Select_Flag, unsigned char Address_Flag, unsigned char *uid);

/*
* Function: rfICode_GetMultipleBlockSecurityStatus
*
* Description: 读取卡的多个块的安全状态信息
*
* Input:
*		Select_Flag:  0 -- 根据 Address_flag 的设置选择卡来执行该命令。 1 -- 只有选择状态下的卡能执行该命令
*       Address_Flag:  0 -- 请求不是地址模式，UID 无效，任何卡都执行; 1 -- 请求是地址模式，UID 有较，只有 UID 匹配的卡才 执行该命令。
*       uid: 卡片UID
*		startblock: 起始块号，0 ~ 27
*		blocknum: 读取安全信息的块数
* Output：
*		security: 读取到的安全信息
*
* Return: 等于0成功,其它错误, 请查看错误代码表
*
* Others: 如果 Select_Flag 被设为 1, 则 Address_Flag 应该是 0 并且卡的 UID 无效
*/
short rfICode_GetMultipleBlockSecurityStatus(unsigned char Select_Flag, unsigned char Address_Flag, unsigned char *uid,
	unsigned char startblock, unsigned char blocknum, unsigned char *security);

/*
* Function: rfICode_LockAFI
*
* Description: 锁定AFI
*
* Input:
*		Select_Flag:  0 -- 根据 Address_flag 的设置选择卡来执行该命令。 1 -- 只有选择状态下的卡能执行该命令
*       Address_Flag:  0 -- 请求不是地址模式，UID 无效，任何卡都执行; 1 -- 请求是地址模式，UID 有较，只有 UID 匹配的卡才 执行该命令。
*       uid: 卡片UID
*
* Return: 等于0成功,其它错误, 请查看错误代码表
*
* Others: 如果 Select_Flag 被设为 1, 则 Address_Flag 应该是 0 并且卡的 UID 无效
*/
short rfICode_LockAFI(unsigned char Select_Flag, unsigned char Address_Flag, unsigned char *uid);

/*
* Function: rfICode_SetEAS
*
* Description: 设置EAS位为1
*
* Input:
*		mode:  请求标记. 0 -- 请求能被任何的卡执行; 1 -- 只被选择状态下的卡执行
*
* Return: 等于0成功,其它错误, 请查看错误代码表
*/
short rfICode_SetEAS(unsigned char mode);

/*
* Function: rfICode_ClearEAS
*
* Description: 设置EAS位为0
*
* Input:
*		mode:  请求标记. 0 -- 请求能被任何的卡执行; 1 -- 只被选择状态下的卡执行
*
* Return: 等于0成功,其它错误, 请查看错误代码表
*/
short rfICode_ClearEAS(unsigned char mode);

/*
* Function: rfICode_LockEAS
*
* Description: 锁定EAS
*
* Input:
*		mode:  请求标记. 0 -- 请求能被任何的卡执行; 1 -- 只被选择状态下的卡执行
*
* Return: 等于0成功,其它错误, 请查看错误代码表
*/
short rfICode_LockEAS(unsigned char mode);

/*
* Function:	rfICode_SetPassword
*
* Description: With this command the different passwords can be transmitted to the label.
*			   This command has to be executed just once for the related passwords if the label is powered.
*
* Input:
*		Select_Flag: 0 -- 根据 Address_flag 的设置选择卡来执行该命令; 1 -- 只有选择状态下的卡能执行该命令
*		Address_Flag: 0 -- 请求不是地址模式，UID 无效，任何卡都执行; 1 -- 请求是地址模式，UID 有较，只有 UID 匹配的卡才 执行该命令。
*		bPwdIdentifier:	Password Identifier.
*						0x01 -- Read.
*						0x02 -- Write.
*						0x04 -- Privacy.
*						0x08 -- Destroy.
*		uid: 标签 UID
*		pPwd: Password.
*
* Return: 等于0成功,其它错误, 请查看错误代码表
*/
short rfICode_SetPassword(unsigned char Select_Flag, unsigned char Address_Flag, unsigned char bPwdIdentifier, unsigned char *uid, unsigned char * pPwd);

/*
* Function: rfICode_WritePassword
*
* Description: This command enables a new password to be written into the related memory if the related old password has
*			   already been transmitted with phalICode_SetPassword command and the addressed password is not locked.
*			   The new password takes effect immediately which means that the new password has to be transmitted with
*			   rfICode_SetPassword() to get access to protected blocks/pages.
*
* Input:
*		Select_Flag: 0 -- 根据 Address_flag 的设置选择卡来执行该命令。 1 -- 只有选择状态下的卡能执行该命令
*		Address_Flag: 0 -- 请求不是地址模式，UID 无效，任何卡都执行; 1 -- 请求是地址模式，UID 有较，只有 UID 匹配的卡才 执行该命令。
*		bPwdIdentifier:	Password Identifier.
*						0x01 -- Read.
*						0x02 -- Write.
*						0x04 -- Privacy.
*						0x08 -- Destroy.
*		uid: 标签 UID
*		pPwd: New password.
*
* Return:	    等于0成功,其它错误, 请查看错误代码表
*/
short rfICode_WritePassword(unsigned char Select_Flag, unsigned char Address_Flag, unsigned char bPwdIdentifier, unsigned char *uid, unsigned char * pPwd);


short iReadSocialSecurityCardBas(char* pCardInfo);
short iReadSocialSecurityCardInfo(char* pCardInfo);

/************** 身份证 ***********************************************/

short hc_ID_Read();
short hc_ID_GetName(char* pName, int* strLen);
short hc_ID_GetSex(char* pSex, int* strLen);
short hc_ID_GetNation(char* pNation, int* strLen);
short hc_ID_GetBirthday(char* pBirthday, int* strLen);
short hc_ID_GetAddress(char* pAddress, int* strLen);
short hc_ID_GetNumber(char* pNumber, int* strLen);
short hc_ID_GetDepartment(char* pDepartment, int* strLen);
short hc_ID_GetExpiryDate(char* pExpiryDate, int* strLen);
short hc_ID_GetPhoto_Bmp(const char* bmpPath);
short hc_GetSAMID(unsigned char* samId, int* strLen);

//////////////////////////////// 超高频 (M100模组)//////////////////////////////////////////////////

/**
* Function: uhf_TAG_Inventory
*
* Description: 完成一次 EPCClass1Gen2 协议中轮询 Inventory 操作. 标签操作之前必须先执行此命令。
*
* Output:
*		Rssi: RSSI反映的是芯片输入端信号大小，不包含天线增益和定向耦合器衰减等。RSSI 为芯片输入端信号强度， 十六进制有符号数，单位为 dBm。如 RSSI 为 0xC9，代表芯片输入端信号强度为-55dBm。
*		pc: 2 字节协议控制
*		epc: 标签的产品电子代码
*		epcLen: EPC 的实际长度(字节)
*		crc: 循环冗余校验,2 字节
*
* Return: 等于0成功, 小于0表示失败.
*/
short uhf_TAG_Inventory(char* Rssi, unsigned char* pc, unsigned char *epc, unsigned char *epcLen, unsigned char* crc);

/**
* Function: uhf_TAG_Select_Set
*
* Description: 设置 Select 参数，并且同时设置 Select 模式为 0x02。在多标签的情况下,可以根据 Select 参数只对特定标签进行轮询和读写等操作
*
* Input:
*		epc: 要选择标签的产品电子代码
*		epcLen: EPC 的实际长度(字节)
*
* Return: 等于0成功, 小于0表示失败.
*/
short uhf_TAG_Select_Set(unsigned char *EPC, unsigned char epcLen);

/**
* Function: uhf_TAG_Select_Mode
*
* Description: 如果已经设置好了 Select 参数，执行该条指令，可以设置 Select 模式
*
* Input:
*		Mode: 0x00 -- 在对标签的所有操作之前都预先发送 Select 指令选取特定的标签。
*			  0x01 -- 在对标签操作之前不发送 Select 指令
*			  0x02 -- 仅对除轮询 Inventory 之外的标签操作之前发送 Select 指令，如在 Read，Write，Lock，Kill 之前先通过 Select 选取特定的标签。
*
* Return: 等于0成功, 小于0表示失败.
*/
short uhf_TAG_Select_Mode(unsigned char Mode);

/**
* Function: uhf_TAG_Read
*
* Description: 读取标签数据存储区 Memory Bank 中指定地址和长度的数据
*
* Input:
*		password: Access Password, 4 bytes.
*		memBank: 所要读取的区域. 0 -- RFU 区; 1 -- EPC 区; 2 -- TID 区; 3 -- User 区
*		offset: 读取的起始地址,以 word 为单位即 2 个 Byte/16 个 Bit.
*		len: 要读取的长度, 以 word 为单位即 2 个 Byte/16 个 Bit.
* Output:
*		data_buffer: 读取到的数据, 字节长度为 len * 2
*		pc: 返回所操作标签的 PC, 2 字节.
*		epc: 返回所操作标签的 EPC.
*		epcLen: 返回 EPC 的实际长度(字节).
*
* Return: 等于0成功, 小于0表示失败.
*/
short uhf_TAG_Read(unsigned char* password, unsigned char memBank, short offset, short len,
	unsigned char* data_buffer, unsigned char* pc, unsigned char *epc, unsigned char *epcLen);

/**
* Function: uhf_TAG_Write
*
* Description: 写入标签数据存储区 Memory Bank 中指定地址和长度的数据
*
* Input:
*		password: Access Password, 4 bytes.
*		memBank: 所要写入的区域. 0 -- RFU 区; 1 -- EPC 区; 2 -- TID 区; 3 -- User 区
*		offset: 写入的起始地址,以 word 为单位即 2 个 Byte/16 个 Bit.
*		len: 写入的数据长度, 以 word 为单位即 2 个 Byte/16 个 Bit.
*		data_buffer: 写入的数据, 字节长度为 len * 2
* Output:
*		pc: 返回所操作标签的 PC, 2 字节.
*		epc: 返回所操作标签的 EPC.
*		epcLen: 返回 EPC 的实际长度(字节).
*
* Return: 等于0成功, 小于0表示失败.
*/
short uhf_TAG_Write(unsigned char* password, unsigned char memBank, short offset, short len,
	unsigned char* data_buffer, unsigned char* pc, unsigned char *epc, unsigned char *epcLen);

/**
* Function: uhf_TAG_Lock
*
* Description: 对单个标签，锁定 Lock 或者解锁 Unlock 该标签的数据存储区。
*
* Input:
*		password:			Access Password
*		bKillPwdAction:		Kill Password 的锁定状态. 最高位代表是否更改其锁定状态, 0 -- 不更改, 1 -- 更改
*							当最高位为 1 时, 其它位取值如下
*							0 -- Open 开放, 即 kill password 可从打开或安全状态读写.
*								 Associated password location is readable and writeable from either the open or secured states.
*							1 -- Perma Open 永久开放, 即 kill password 可从打开或安全状态永久读取和写入, 并且可能永远不会被锁定.
*								 Associated password location is permanently readable and writeable from either the open or secured states and may never be locked.
*							2 -- Lock 锁定, 即 kill password 在安全状态下可读写，但在打开状态下不可读写.
*								 Associated password location is not readable or writeable from any state.
*							3 -- Perma Lock, 即 kill password 无法从任何状态读取或写入.
*								 Associated password location is not readable or writeable from any state.
*		bAccessPwdAction:	Access Password 的锁定状态. 最高位代表是否更改其锁定状态, 0 -- 不更改, 1 -- 更改
*							当最高位为 1 时, 其它位取值如下
*							0 -- Open 开放, 即 Access password 可从打开或安全状态读写.
*								 Associated password location is readable and writeable from either the open or secured states.
*							1 -- Perma Open 永久开放, 即 Access password 可从打开或安全状态永久读取和写入, 并且可能永远不会被锁定.
*								 Associated password location is permanently readable and writeable from either the open or secured states and may never be locked.
*							2 -- Lock 锁定, 即 Access password 在安全状态下可读写，但在打开状态下不可读写.
*								 Associated password location is not readable or writeable from any state.
*							3 -- Perma Lock, 即 Access password 无法从任何状态读取或写入.
*								 Associated password location is not readable or writeable from any state.
*		bEPCMemoryAction:	EPC Memory 的锁定状态. 最高位代表是否更改其锁定状态, 0 -- 不更改, 1 -- 更改
*							当最高位为 1 时, 其它位取值如下
*							0 -- Open 开放, 即 EPC Memory 可从打开或安全状态写入.
*								 Associated memory bank is writeable from either the open or secured states.
*							1 -- Perma Open 永久开放, 即 EPC Memory 可从打开或安全状态永久写入, 并且可能永远不会被锁定.
*								 Associated memory bank is permanently writeable from either the open or secured states and may never be locked.
*							2 -- Lock 锁定, 即 EPC Memory 可从安全状态写入, 但不能从打开状态写入.
*								 Associated memory bank is writeable from the secured state but not from the open state.
*							3 -- Perma Lock 永久锁定, 即 EPC Memory 不能从任何状态写入.
*								 Associated memory bank is not writeable from any state.
*		bTIDMemoryAction:	TID Memory 的锁定状态. 最高位代表是否更改其锁定状态, 0 -- 不更改, 1 -- 更改
*							当最高位为 1 时, 其它位取值如下
*							0 -- Open 开放, 即 TID Memory 可从打开或安全状态写入.
*								 Associated memory bank is writeable from either the open or secured states.
*							1 -- Perma Open 永久开放, 即 TID Memory 可从打开或安全状态永久写入, 并且可能永远不会被锁定.
*								 Associated memory bank is permanently writeable from either the open or secured states and may never be locked.
*							2 -- Lock 锁定, 即 TID Memory 可从安全状态写入, 但不能从打开状态写入.
*								 Associated memory bank is writeable from the secured state but not from the open state.
*							3 -- Perma Lock 永久锁定, 即 TID Memory 不能从任何状态写入.
*								 Associated memory bank is not writeable from any state.
*		bUserMemoryAction:	User Memory 的锁定状态. 最高位代表是否更改其锁定状态, 0 -- 不更改, 1 -- 更改
*							当最高位为 1 时, 其它位取值如下
*							0 -- Open 开放, 即 User Memory 可从打开或安全状态写入.
*								 Associated memory bank is writeable from either the open or secured states.
*							1 -- Perma Open 永久开放, 即 User Memory 可从打开或安全状态永久写入, 并且可能永远不会被锁定.
*								 Associated memory bank is permanently writeable from either the open or secured states and may never be locked.
*							2 -- Lock 锁定, 即 User Memory 可从安全状态写入, 但不能从打开状态写入.
*								 Associated memory bank is writeable from the secured state but not from the open state.
*							3 -- Perma Lock 永久锁定, 即 User Memory 不能从任何状态写入.
*								 Associated memory bank is not writeable from any state.
*
* Returns: Status code, == 0 succeeded, < 0 failed.
*/
short uhf_TAG_Lock(unsigned char* password, unsigned char bKillPwdAction, unsigned char bAccessPwdAction,
	unsigned char bEPCMemoryAction, unsigned char bTIDMemoryAction, unsigned char bUserMemoryAction);

/**
* Function: uhf_U9_Lock
*
* Description: 锁定 Lock U9 标签。
*
* Input:
*		password:			Access Password
*
* Returns: Status code, == 0 succeeded, < 0 failed.
*/
short uhf_U9_Lock(unsigned char* password);

/**
* Function: uhf_TAG_Kill
*
* Description: 灭活Kill标签。这条指令之前应先设置 Select 参数，以便选择指定的标签进行灭活 Kill 操作。对单标签的灭活操作。
*			   注意: 标签如果没有设置过 Kill Password 密码，即 Kill Password 密码全为 0，按照 Gen2 协议，标签不会被 Kill。
*
* Input:
*		password: Kill Password, 4 字节
*
* Return: 等于0成功, 小于0表示失败.
*/
short uhf_TAG_Kill(unsigned char *password);

/**
* Function: uhf_TAG_Region_Set
*
* Description: 设置读写器工作地区
*
* Input:
*		regionCode: 0x01 -- 中国 900MHz; 0x04 -- 中国 800MHz; 0x02 -- 美国; 0x03 -- 欧洲; 0x06 -- 韩国.
*
* Return: 等于0成功, 小于0表示失败.
*/
short uhf_TAG_Region_Set(unsigned char regionCode);

/**
* Function: uhf_TAG_Channel_Set
*
* Description: 设置读写器工作信道
*
* Input:
*		CH_Index: 信道代号 Channel Index, 计算公式如下(Freq_CH 为信道频率)
*				  中国 900MHz 信道 CH_Index = (Freq_CH - 920.125M) / 0.25M
*				  中国 800MHz 信道 CH_Index = (Freq_CH - 840.125M) / 0.25M
*				  美国信道 CH_Index = (Freq_CH - 902.25M) / 0.5M
*				  欧洲信道 CH_Index = (Freq_CH - 865.1M) / 0.2M
*				  韩国信道 CH_Index = (Freq_CH - 917.1M) / 0.2M
*
* Return: 等于0成功, 小于0表示失败.
*/
short uhf_TAG_Channel_Set(unsigned char CH_Index);

/**
* Function: uhf_TAG_Channel_Get
*
* Description: 获取读写器工作信道
*
* Output:
*		CH_Index: 信道代号 Channel Index, 计算公式如下(Freq_CH 为信道频率)
*				  中国 900MHz 信道 CH_Index = (Freq_CH - 920.125M) / 0.25M
*				  中国 800MHz 信道 CH_Index = (Freq_CH - 840.125M) / 0.25M
*				  美国信道 CH_Index = (Freq_CH - 902.25M) / 0.5M
*				  欧洲信道 CH_Index = (Freq_CH - 865.1M) / 0.2M
*				  韩国信道 CH_Index = (Freq_CH - 917.1M) / 0.2M
*
* Return: 等于0成功, 小于0表示失败.
*/
short uhf_TAG_Channel_Get(unsigned char* CH_Index);

/**
* Function: uhf_TAG_HFSS_Set
*
* Description: 自动跳频设置
*
* Input:
*		hfss: 0 -- 取消自动跳频; 1 -- 设置自动跳频
*
* Return: 等于0成功, 小于0表示失败.
*/
short uhf_TAG_HFSS_Set(unsigned char hfss);

/**
* Function: uhf_TAG_PaPower_Get
*
* Description: 获取当前读写器发射功率
*
* Output:
*		papower: 读写器的发射功率，如2000，即 20dBm
*
* Return: 等于0成功, 小于0表示失败.
*/
short uhf_TAG_PaPower_Get(unsigned short *papower);

/**
* Function: uhf_TAG_PaPower_Set
*
* Description: 设置当前读写器发射功率
*
* Input:
*		papower: 读写器的发射功率，如2000，即 20dBm
*
* Return: 等于0成功, 小于0表示失败.
*/
short uhf_TAG_PaPower_Set(unsigned short papower);

/**
* Function: uhf_TAG_CW_Set
*
* Description: 设置发射连续载波
*
* Input:
*		cw: 0 -- 关闭连续载波; 1 -- 打开连续载波
*
* Return: 等于0成功, 小于0表示失败.
*/
short uhf_TAG_CW_Set(unsigned char cw);

/**
* Function: uhf_TAG_Modem_Get
*
* Description: 获取当前读写器接收解调器参数。
*
* Output:
*		modemParam: 接收解调器参数,4 字节,含义如下
*					modemParam[0]: 混频器 Mixer 增益. 如0x03(混频器 Mixer 增益为 9dB)
*					modemParam[1]: 中频放大器增益 IF_G: 如0x06(中频放大器 IFAMP 增益为 36dB)
*					modemParam[2][3]: 信号解调阈值 Thrd. 信号解调阈值越小能解调的标签返回 RSSI 越低，但越不稳定，低于一 定值完全不能解调；
*									  相反阈值越大能解调的标签返回信号 RSSI 越大，距离越近，越稳定。0x01B0 是推荐的 最小值)
*
* Return: 等于0成功, 小于0表示失败.
*/
short uhf_TAG_Modem_Get(unsigned char* modemParam);

/**
* Function: uhf_TAG_Modem_Set
*
* Description: 设置当前读写器接收解调器参数。
*
* Input:
*		modemParam: 接收解调器参数,4 字节,含义如下
*					modemParam[0]: 混频器 Mixer 增益. 如0x03(混频器 Mixer 增益为 9dB)
*					modemParam[1]: 中频放大器增益 IF_G: 如0x06(中频放大器 IFAMP 增益为 36dB)
*					modemParam[2][3]: 信号解调阈值 Thrd. 信号解调阈值越小能解调的标签返回 RSSI 越低，但越不稳定，低于一 定值完全不能解调；
*									  相反阈值越大能解调的标签返回信号 RSSI 越大，距离越近，越稳定。0x01B0 是推荐的 最小值)
*
* Return: 等于0成功, 小于0表示失败.
*/
short uhf_TAG_Modem_Set(unsigned char* modemParam);


